      SUBROUTINE XDGEEV(N,A,WORK,WR,WI,VL,VR,INFO)
*     This is manually written wrapper function needed in order to
*     call LAPACK routine "DGEEV" from MathCode. 
*     The routine computes eigenvalues and eigenvectors of given
*     (square) matrix A.
*     See more documentation  in LAPACK source  code, dgeev.f

*     Inputs:
      INTEGER N
      DOUBLE PRECISION A(N,N)
      DOUBLE PRECISION WORK(N*4)

*     InOut: These variables are needed at output (values)
*      and at input - to allocate corresponding memory 
      DOUBLE PRECISION WR(N),WI(N),VL(N,N),VR(N,N)

*     Outputs
      INTEGER INFO

      EXTERNAL DGEEV

      CHARACTER          JOBVL, JOBVR
      JOBVL='V'
      JOBVR='V'
      LDA=N
      LDVL=N
      LDVR=N
      LWORK=4*N
      CALL  DGEEV( JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR,
     $                  LDVR, WORK, LWORK, INFO )
      RETURN
      END
